unit ftestipcserver;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, simpleipc,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    FIPCServer: TSimpleIPCServer;
    procedure Receive (Sender: TObject);
    procedure AppIdle(Sender: TObject; var Done: Boolean);
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$ifdef unix}
  Application.OnIdle:=@AppIdle;
  {$endif}
  FIPCServer:=TSimpleIPCServer.Create(Self);
  with FIPCServer do
  begin
    OnMessage:=@Receive;
    ServerID:='test_msgtype';
    Global:=True;
    StartServer;
  end;
end;

procedure TForm1.Receive(Sender: TObject);
var
  AStr: String;
begin
  with FIPCServer do
  begin
    case MsgType of
    mtString:AStr:='A default (mtString) message: ';
    9:AStr:= 'A message of type 9: ';
    88:AStr:= 'A message of type 88: ';
    else
      AStr:= 'Unknow message type ('+IntToStr(MsgType)+'): ';
    end;
    ListBox1.Items.Add(AStr+StringMessage);
  end;
end;

procedure TForm1.AppIdle(Sender: TObject; var Done: Boolean);
begin
  FIPCServer.PeekMessage(1,True);
end;

initialization
  {$I ftestipcserver.lrs}

end.

